/* $Id: init.c,v 1.6 2002/10/17 22:19:29 xi Exp $ */

/* ############################################################################
#    Minimal-router - a small linux based internet router
#    Copyright (C) 2002  Christian Laursen <xi@borderworlds.dk>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
############################################################################ */

#include <sys/mount.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "config.c"

void mount_proc ()
{
  puts("Mounting /proc...");
  mount("none", "/proc", "proc", 0, "");
}

void enable_forwarding ()
{
  FILE *fil;

  puts("Enabling IP forwarding...");

  if ((fil = fopen ("/proc/sys/net/ipv4/ip_forward", "w")) == NULL) {
    puts ("Couldn't enable IP forwarding :(");
    exit(1);
  }
  fputs("1\n", fil);
  fclose (fil);
}

int main ()
{
  FILE *fil;
  char str[256];
  int i,l,tmp;
  int days, hours, mins, secs;

  printf("%c[9;0]", 0x1b); /* Disable screen blanker */

  print_welcome();

  printf("%c[00;32m", 0x1b); /* Change the color */

  mount_proc();
  run_commands();
  enable_forwarding();

  puts("All done\n");

  sleep(10);
  puts("\n");

  printf("%c[00m", 0x1b); /* Change the color back */

  while (1) {
    if ((fil = fopen ("/proc/uptime", "r")) == NULL) {
      puts ("Couldn't read uptime :(");
      exit(1);
    }
    fgets(str, 256, fil);
    fclose (fil);
    l = strlen(str);
    for (i = 0; i < l; ++i) {
      if (str[i] == '.') {
	str[i] = 0;
      }
    }

    tmp = atoi(str);

    days = tmp / (60*60*24);
    hours = tmp % (60*60*24) / (60*60);
    mins = tmp % (60*60) / 60;
    secs = tmp % (60);

    if (days == 1) {
      printf("Uptime:  %3d day,  %02d:%02d:%02d          \r", days, hours, mins, secs);
    } else {
      printf("Uptime:  %3d days, %02d:%02d:%02d          \r", days, hours, mins, secs);
    }
    fflush(NULL);

    sleep(1);
  }

  puts("The world has come to an end");
}
